"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Referral(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "clinicalIndication",
        "referralId",
        "referralTests",
        "referralUid",
        "requester",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import participant as participant_1_5_0

        return {
            "birthClinicalQuestions": participant_1_5_0.BirthClinicalQuestions,
            "cancerParticipant": participant_1_5_0.CancerParticipant,
            "clinicalIndication": participant_1_5_0.ClinicalIndication,
            "orderingDate": participant_1_5_0.Date,
            "pedigree": participant_1_5_0.Pedigree,
            "referralTests": participant_1_5_0.ReferralTest,
            "requester": participant_1_5_0.OrganisationNgis,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import participant as participant_1_5_0

        return {
            "org.gel.models.participant.avro.BirthClinicalQuestions": participant_1_5_0.BirthClinicalQuestions,
            "org.gel.models.participant.avro.CancerParticipant": participant_1_5_0.CancerParticipant,
            "org.gel.models.participant.avro.ClinicalIndication": participant_1_5_0.ClinicalIndication,
            "org.gel.models.participant.avro.Date": participant_1_5_0.Date,
            "org.gel.models.participant.avro.Pedigree": participant_1_5_0.Pedigree,
            "org.gel.models.participant.avro.ReferralTest": participant_1_5_0.ReferralTest,
            "org.gel.models.participant.avro.OrganisationNgis": participant_1_5_0.OrganisationNgis,
            "org.gel.models.participant.avro.Referral": participant_1_5_0.Referral,
        }

    __slots__ = [
        "clinicalIndication",
        "referralId",
        "referralTests",
        "referralUid",
        "requester",
        "birthClinicalQuestions",
        "cancerParticipant",
        "collection",
        "orderingDate",
        "pedigree",
    ]

    def __init__(
        self,
        clinicalIndication,
        referralId,
        referralTests,
        referralUid,
        requester,
        birthClinicalQuestions=None,
        cancerParticipant=None,
        collection=None,
        orderingDate=None,
        pedigree=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_5_0.Referral model.

        :param clinicalIndication:
            Clinical Indication of the referral
        :type clinicalIndication: ClinicalIndication
        :param referralId:
            Referral unique identifier (to be displayed)
        :type referralId: str
        :param referralTests:
            List of tests associated to the referral
        :type referralTests: list[ReferralTest]
        :param referralUid:
            Referral internal unique identifier
        :type referralUid: str
        :param requester:
            Requesting Organisation of the Referral
        :type requester: OrganisationNgis
        :param birthClinicalQuestions:
            Clinical questions asked at birth, in case this referral belongs to a
            newborn.
        :type birthClinicalQuestions: None | BirthClinicalQuestions
        :param cancerParticipant:
            Cancer Participant
        :type cancerParticipant: None | CancerParticipant
        :param collection:
            Collection common identifier for research cohorts using GMS Framework
        :type collection: None | str
        :param orderingDate:
            Date of referral being created
        :type orderingDate: None | Date
        :param pedigree:
            Pedigree
        :type pedigree: None | Pedigree
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.0"
